/*
name:             complog_xsl_script.rex
author:           Rainer Kegel
date:             2007-01-02

purpose:          part of the Test Runner Application for ooRexxUnit
- provides routines for complog.xsl

license:          CPL 1.0 (Common Public License v1.0, see below)

*/

/*----------------------------------------------------------------------------*/
/*                                                                            */
/* Copyright (c) 2007 Rainer Kegel. All rights reserved.                      */
/*                                                                            */
/* This program and the accompanying materials are made available under       */
/* the terms of the Common Public License v1.0 which accompanies this         */
/* distribution. A copy is also available at the following address:           */
/* http://www.opensource.org/licenses/cpl1.0.php                              */
/*                                                                            */
/* Redistribution and use in source and binary forms, with or                 */
/* without modification, are permitted provided that the following            */
/* conditions are met:                                                        */
/*                                                                            */
/* Redistributions of source code must retain the above copyright             */
/* notice, this list of conditions and the following disclaimer.              */
/* Redistributions in binary form must reproduce the above copyright          */
/* notice, this list of conditions and the following disclaimer in            */
/* the documentation and/or other materials provided with the distribution.   */
/*                                                                            */
/* Neither the name of Rexx Language Association nor the names                */
/* of its contributors may be used to endorse or promote products             */
/* derived from this software without specific prior written permission.      */
/*                                                                            */
/* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS        */
/* "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT          */
/* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS          */
/* FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT   */
/* OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,      */
/* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED   */
/* TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,        */
/* OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY     */
/* OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING    */
/* NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS         */
/* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.               */
/*                                                                            */
/*----------------------------------------------------------------------------*/



::routine buttons public
   checkboth=document~getelementbyid("both1")
   checkonce=document~getelementbyid("once1")
   if checkboth=.nil then
   document~getelementbyid("buttonrunboth")~style~display="none"
   if checkonce=.nil then
   document~getelementbyid("buttonrunonce")~style~display="none"
   
::routine changes public
   len=document~stylesheets[0]~rules~length
   do i=0 to len-1
      check=document~stylesheets[0]~rules[i]~selectortext
      if check=".changes" then
      do
         len=i
         check1=document~stylesheets[0]~rules[i]~style~display
         if check1="inline" then
         do
            document~stylesheets[0]~rules[i]~style~display="none"
            document~getelementbyid("buttonchanges")~value="show changes"
         end
         if check1="none" then
         do
            document~stylesheets[0]~rules[i]~style~display="inline"
            document~getelementbyid("buttonchanges")~value="hide changes"
         end
      end
   end
   
::routine log1 public
   r_both=0
   r_once=0
   checkboth=document~getelementbyid("both1")
   checkonce=document~getelementbyid("once1")
   if checkboth\=.nil then
   r_both=1
   if checkonce\=.nil then
   r_once=1
   
   len=document~stylesheets[0]~rules~length
   do i=0 to len-1
      check=document~stylesheets[0]~rules[i]~selectortext
      if check=".log1" then
      do
         check1=document~stylesheets[0]~rules[i]~style~display
         len=i
         if check1="inline" then
         do
            document~stylesheets[0]~rules[i]~style~display="none"
            document~getelementbyid("buttonlog1")~value="show log1"
         end
         if check1="none" then
         do
            document~stylesheets[0]~rules[i]~style~display="inline"
            document~getelementbyid("buttonlog1")~value="hide log1"
         end
         lenb=document~stylesheets[0]~rules~length
         do x=0 to lenb-1
            checkb=document~stylesheets[0]~rules[x]~selectortext
            if checkb=".log2" then
            do
               log2check=document~stylesheets[0]~rules[x]~style~display
               lenb=x
               checkdisplay=document~stylesheets[0]~rules[i]~style~display
               if (checkdisplay="none") then
               if (log2check="none") then
               do
                  document~getelementbyid("buttonrunboth")~style~display="none"
                  document~getelementbyid("buttonrunonce")~style~display="none"
               end
               if checkdisplay="inline" then
               if r_both=1 then
               document~getelementbyid("buttonrunboth")~style~display="inline"
               
               if checkdisplay="inline" then
               if r_once=1 then
               document~getelementbyid("buttonrunonce")~style~display="inline"
               
               if log2check="inline" then
               if r_both=1 then
               document~getelementbyid("buttonrunboth")~style~display="inline"
               
               if log2check="inline" then
               if r_once=1 then
               document~getelementbyid("buttonrunonce")~style~display="inline"
            end
         end
      end
   end
   
::routine log2 public
   r_both=0
   r_once=0
   checkboth=document~getelementbyid("both1")
   checkonce=document~getelementbyid("once1")
   if checkboth\=.nil then
   r_both=1
   if checkonce\=.nil then
   r_once=1
   
   len=document~stylesheets[0]~rules~length
   do i=0 to len-1
      check=document~stylesheets[0]~rules[i]~selectortext
      if check=".log2" then
      do
         check1=document~stylesheets[0]~rules[i]~style~display
         len=i
         if check1="inline" then
         do
            document~stylesheets[0]~rules[i]~style~display="none"
            document~getelementbyid("buttonlog2")~value="show log2"
         end
         if check1="none" then
         do
            document~stylesheets[0]~rules[i]~style~display="inline"
            document~getelementbyid("buttonlog2")~value="hide log2"
         end
         lenb=document~stylesheets[0]~rules~length
         do x=0 to lenb-1
            checkb=document~stylesheets[0]~rules[x]~selectortext
            if checkb=".log1" then
            do
               log1check=document~stylesheets[0]~rules[x]~style~display
               lenb=x
               checkdisplay=document~stylesheets[0]~rules[i]~style~display
               if (checkdisplay="none") then
               if (log1check="none") then
               do
                  document~getelementbyid("buttonrunboth")~style~display="none"
                  document~getelementbyid("buttonrunonce")~style~display="none"
               end
               if checkdisplay="inline" then
               if r_both=1 then
               document~getelementbyid("buttonrunboth")~style~display="inline"
               if checkdisplay="inline" then
               if r_once=1 then
               document~getelementbyid("buttonrunonce")~style~display="inline"
               if  log1check="inline" then
               if r_both=1 then
               document~getelementbyid("buttonrunboth")~style~display="inline"
               if  log1check="inline" then
               if r_once=1 then
               document~getelementbyid("buttonrunonce")~style~display="inline"
            end
         end
      end
   end
   
::routine runboth public
   len=document~stylesheets[0]~rules~length
   do i=0 to len-1
      check=document~stylesheets[0]~rules[i]~selectortext
      if check=".runboth" then
      do
         len=i
         check1=document~stylesheets[0]~rules[i]~style~display
         if check1="inline" then
         do
            document~stylesheets[0]~rules[i]~style~display="none"
            document~getelementbyid("buttonrunboth")~value="show runboth"
         end
         if check1="none" then
         do
            document~stylesheets[0]~rules[i]~style~display="inline"
            document~getelementbyid("buttonrunboth")~value="hide runboth"
         end
      end
   end
   
::routine runonce public
   len=document~stylesheets[0]~rules~length
   do i=0 to len-1
      check=document~stylesheets[0]~rules[i]~selectortext
      if check=".runonce" then
      do
         len=i
         check1=document~stylesheets[0]~rules[i]~style~display
         if check1="inline" then
         do
            document~stylesheets[0]~rules[i]~style~display="none"
            document~getelementbyid("buttonrunonce")~value="show runonce"
         end
         if check1="none" then
         do
            document~stylesheets[0]~rules[i]~style~display="inline"
            document~getelementbyid("buttonrunonce")~value="hide runonce"
         end
      end
   end
