/*
name:             complog_xsl_script.rex
author:           Rainer Kegel
date:             2007-01-02

purpose:          part of the Test Runner Application for ooRexxUnit
- provides routines for complog.xsl

license:          CPL 1.0 (Common Public License v1.0, see below)

*/

/*----------------------------------------------------------------------------*/
/*                                                                            */
/* Copyright (c) 2007 Rainer Kegel. All rights reserved.                      */
/*                                                                            */
/* This program and the accompanying materials are made available under       */
/* the terms of the Common Public License v1.0 which accompanies this         */
/* distribution. A copy is also available at the following address:           */
/* http://www.opensource.org/licenses/cpl1.0.php                              */
/*                                                                            */
/* Redistribution and use in source and binary forms, with or                 */
/* without modification, are permitted provided that the following            */
/* conditions are met:                                                        */
/*                                                                            */
/* Redistributions of source code must retain the above copyright             */
/* notice, this list of conditions and the following disclaimer.              */
/* Redistributions in binary form must reproduce the above copyright          */
/* notice, this list of conditions and the following disclaimer in            */
/* the documentation and/or other materials provided with the distribution.   */
/*                                                                            */
/* Neither the name of Rexx Language Association nor the names                */
/* of its contributors may be used to endorse or promote products             */
/* derived from this software without specific prior written permission.      */
/*                                                                            */
/* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS        */
/* "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT          */
/* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS          */
/* FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT   */
/* OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,      */
/* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED   */
/* TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,        */
/* OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY     */
/* OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING    */
/* NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS         */
/* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.               */
/*                                                                            */
/*----------------------------------------------------------------------------*/



::routine okay public
   len=document~stylesheets[0]~rules~length
   do i=0 to len-1
      check=document~stylesheets[0]~rules[i]~selectortext
      if check=".okay" then
      do
         len=i
         check1=document~stylesheets[0]~rules[i]~style~display
         if check1="inline" then
         do
            document~stylesheets[0]~rules[i]~style~display="none"
            document~getelementbyid("buttonokay")~value="show okay"
         end
         if check1="none" then
         do
            document~stylesheets[0]~rules[i]~style~display="inline"
            document~getelementbyid("buttonokay")~value="hide okay"
         end
      end
   end
   
::routine failure public
   len=document~stylesheets[0]~rules~length
   do i=0 to len-1
      check=document~stylesheets[0]~rules[i]~selectortext
      if check=".failure" then
      do
         len=i
         check1=document~stylesheets[0]~rules[i]~style~display
         if check1="inline" then
         do
            document~stylesheets[0]~rules[i]~style~display="none"
            document~getelementbyid("buttonfailure")~value="show failure"
         end
         if check1="none" then
         do
            document~stylesheets[0]~rules[i]~style~display="inline"
            document~getelementbyid("buttonfailure")~value="hide failure"
         end
      end
   end
   
::routine error public
   len=document~stylesheets[0]~rules~length
   do i=0 to len-1
      check=document~stylesheets[0]~rules[i]~selectortext
      if check=".error" then
      do
         len=i
         check1=document~stylesheets[0]~rules[i]~style~display
         if check1="inline" then
         do
            document~stylesheets[0]~rules[i]~style~display="none"
            document~getelementbyid("buttonerror")~value="show error"
         end
         if check1="none" then
         do
            document~stylesheets[0]~rules[i]~style~display="inline"
            document~getelementbyid("buttonerror")~value="hide error"
         end
      end
   end
